<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import { api, api_key_tiny_editor, regexEmail } from "~/common/constaint";
import { listTemplate } from "~/common/termMail";
import _ from "lodash";
@Component({})
export default class AdminSettingsEmailComponent extends Vue {
  api_key_tiny_editor = api_key_tiny_editor;
  tab = 0;

  slug = "";

  email = "";
  tempEmail: any = "";

  created() {
    this.slug = this.$route.params?.slug.replaceAll("-", " ") || "";
    this.orderName = `${this.slug} {{order_name}}`;
    this.tempEmail =
      listTemplate.find((temp) => temp.name === this.slug)?.template || "";
  }

  order = {
    detail: "",
    email: "",
    variantCustom: `{{sender}} = ${window.location.host}\n{{recevied_email}}\n{{order_name}}`,
  };

  orderName = "";

  resetContent = false;

  async onSendMain() {
    try {
      if (!this.email) {
        return this.$pushNotification.error(`Please enter email`);
      } else if (!regexEmail.test(this.email)) {
        return this.$pushNotification.error(`Email not invalid`);
      }
      if (this.slug === "order confirmation") {
        await this.$api.adminSendMail.sendOrderConfirm(this.email);
      }
      if (this.slug === "order change billing") {
        await this.$api.adminSendMail.sendOrderChangeShipping(this.email);
      }
      if (this.slug === "order cancel") {
        await this.$api.adminSendMail.sendOrderCancel(this.email);
      }
      if (this.slug === "order fulfilled") {
        await this.$api.adminSendMail.sendOrderTracking(this.email);
      }
      this.$pushNotification.success("Send email successfully");
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  get initEditor() {
    return {
      height: 400,
      image_title: true,
      automatic_uploads: true,
      //@ts-ignore
      file_picker_callback: function (cb, value, meta) {
        var input = document.createElement("input");
        input.setAttribute("type", "file");
        input.setAttribute("accept", "image/*");
        input.onchange = function () {
          //@ts-ignore
          var file = this.files[0];

          var reader = new FileReader();
          reader.onload = function () {
            var id = "blobid" + new Date().getTime();
            var blobCache =
              //@ts-ignore
              tinymce.activeEditor.editorUpload.blobCache;
            //@ts-ignore
            var base64 = reader.result.split(",")[1];
            var blobInfo = blobCache.create(id, file, base64);
            blobCache.add(blobInfo);
            cb(blobInfo.blobUri(), { title: file.name });
          };
          reader.readAsDataURL(file);
        };

        input.click();
      },
      file_picker_types: "image",
      plugins: ["lists link image code help wordcount"],
      toolbar:
        "undo redo | formatselect | bold italic | forecolor alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | image link media template codesample inserttable | charmap emoticons hr | pagebreak nonbreaking anchor toc | insertdatetime | help",
    };
  }
}
</script>

<style></style>
